package experiment.fse15;

import java.util.Collection;
import java.util.LinkedList;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import akka.actor.UntypedActor;

public class CollectorActor extends UntypedActor {

	private static final Logger LOGGER = LoggerFactory.getLogger(CollectorActor.class);

	private final Collection<Object> elements;

	public CollectorActor() {
		this(new LinkedList<Object>());
	}

	public CollectorActor(final Collection<Object> elements) {
		super();
		this.elements = elements;
	}

	@Override
	public void onReceive(Object message) throws Exception {
		elements.add(message);
	}

	@Override
	public void postStop() throws Exception {
		LOGGER.info("stopped: " + elements.size());
		super.postStop();
	}
}
