package experiment.fse15;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import akka.actor.UntypedActor;

public class CounterActor extends UntypedActor {

	private static final Logger LOGGER = LoggerFactory.getLogger(CounterActor.class);
	private int numMessages;

	public CounterActor() {
		super();
	}

	@Override
	public void onReceive(final Object message) throws Exception {
		if (message instanceof StopMessage) {
			onTerminating();
		} else {
			numMessages++;
		}
	}

	private void onTerminating() {
		LOGGER.debug("Terminating...");
	}

	@Override
	public void postStop() throws Exception {
		LOGGER.info("stopped: " + numMessages + " messages");
		super.postStop();
	}
}
